(*   ----Start2w v1.2----
 :
 Start2w v1.2
: Freeware;
  Delphi 5.     5 
    

      Panel.
Start2w    win ,    .

:
FileName: TFileName; -    
AlignImg = (alLeft, alRight); -    . , 
ShowWindow = (SHOWNORMAL, MAXIMIZE, SHOWMINNOACTIVE);  -      (,   , )
FIconIndex: Word; -   (   2)
FImg: TImage; -   ,          
FMoEnColor: TColor; -        
FMoLeColor: TColor; -  ,      
FTxtEnColor: TColor; -        
FTxtLeColor: TColor; -  ,      

     tarasui@aport.ru (׸   );
*)

unit Start2w;

{$R gru.res}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ShellAPI;

type
  TShowWindow = (SHOWNORMAL, MAXIMIZE, SHOWMINNOACTIVE);
  TAlignImg = (alLeft, alRight);   
  TStart2w = class(TPanel)
  private
    { Private declarations }
    FShowWindow: TShowWindow;
    FAlignImg: TAlignImg;
    FImg: TImage;
    FMoEnColor: TColor;
    FMoLeColor: TColor;
    FTxtEnColor: TColor;
    FTxtLeColor: TColor;
    FFileName: TFileName;
    FIconIndex: Word;
    procedure SetAlignImg(Value: TAlignImg);
    procedure SetShowWindow(ShowWindow: TShowWindow);
    procedure SetImg(Value: TImage);
    procedure SetFileName(Value: TFileName);
    procedure ImgClick(Sender: TObject);
  protected
    { Protected declarations }
    procedure Loaded; override;
    PROCEDURE MouseDown(Button : TMouseButton; Shift : TShiftState;
      X, Y : Integer); OVERRIDE;
    PROCEDURE CMMouseEnter(VAR msg:TMessage); message CM_MOUSEENTER;
    PROCEDURE CMMouseLeave(VAR msg: TMessage); message CM_MOUSELEAVE;
  public
    { Public declarations }
    property Canvas;
    CONSTRUCTOR Create(AOwner : TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property AlignImg: TAlignImg read FAlignImg write SetAlignImg;
    property ShowWindow: TShowWindow read FShowWindow write SetShowWindow;
    PROPERTY Img: TImage read FImg write SetImg;
    PROPERTY FileName: TFileName read FFileName write SetFileName;
    PROPERTY MoEnColor: TColor read FMoEnColor write FMoEnColor;
    PROPERTY MoLeColor: TColor read FMoLeColor write FMoLeColor;
    PROPERTY TxtEnColor: TColor read FTxtEnColor write FTxtEnColor;
    PROPERTY TxtLeColor: TColor read FTxtLeColor write FTxtLeColor;
    PROPERTY IconIndex: Word read FIconIndex write FIconIndex;
  end;

procedure Register;

implementation

CONSTRUCTOR TStart2w.Create(AOwner : TComponent);
BEGIN
 INHERITED Create(AOwner);
 Caption := 'Grundic';
 BevelOuter:=bvNone;
 MoLeColor:= clBtnFace;
 MoEnColor:= clHighlight;
 TxtLeColor:= clBlack;
 TxtEnColor:= clWhite;
 Width:=220;
 FImg:=TImage.Create(self);
 Img.Parent:=self;
 Img.Top:=(Height-32)div 2;
 Img.Left:=5;
 Img.Height:=32;
 Img.Width:=32;
 Img.Stretch:=true;
 Img.OnClick:=ImgClick;
 ShowWindow:= SHOWNORMAL;
 FAlignImg := alLeft;
 Loaded;
END;

procedure TStart2w.SetAlignImg(Value: TAlignImg);
begin
 if Value <> AlignImg then
 begin
 FAlignImg := Value;
    if AlignImg = alLeft then
    begin
    Img.Top:=(Height-32)div 2;
    Img.Left:=5;
    end;
//- alRight/alLeft
    if AlignImg = alRight then
    begin
    Img.Top:=(Height-32)div 2;
    Img.Left:=Width-37;
    end;
 end;
end;

procedure TStart2w.SetShowWindow(ShowWindow: TShowWindow);
begin
  FShowWindow := ShowWindow;
end;

procedure TStart2w.ImgClick(Sender: TObject);
var Shift: TShiftState;
begin
Img.Refresh;
MouseDown(mbLeft,Shift,0,0);
end;

procedure TStart2w.SetImg(Value: TImage);
begin
FImg.Picture.Assign(Value);
Invalidate;
end;

procedure TStart2w.SetFileName(Value: TFileName);
begin
if Value <> FileName then
 begin
 FFileName:=(Value);
 Caption :=ExtractFileName(FileName);
 Loaded;
 end;
end;

procedure TStart2w.Loaded;
VAR A: ARRAY [0..78] OF Char;
    i: integer;
begin
if FileName <> '' then
 begin
 StrPCopy(A, FileName);
 i:=ExtractIcon(HInstance, A, IconIndex);
 if i = 0 then
 Img.Picture.BitMap.LoadFromResourceName(HInstance,'gru') else
 Img.Picture.Icon.Handle:= ExtractIcon(HInstance, A, IconIndex);
 end;
end;

PROCEDURE TStart2w.CMMouseEnter(var msg : TMessage);
begin
 Color:= FMoEnColor;
 Font.Color := TxtEnColor;
end;

PROCEDURE TStart2w.CMMouseLeave(var msg: TMessage);
BEGIN
 Color:= FMoLeColor;
 Font.Color := TxtLeColor;
END;

PROCEDURE TStart2w.MouseDown(Button : TMouseButton; Shift : TShiftState;
      X, Y : Integer);
VAR A: ARRAY [0..78] OF Char;
    SW: integer;
BEGIN
if Button = mbLeft then
 begin
 if FileName <> '' then
   begin
   StrPCopy(A, FileName);
   //
   if ShowWindow = SHOWNORMAL then SW:=1;
   if ShowWindow = MAXIMIZE then SW:=3;
   if ShowWindow = SHOWMINNOACTIVE then SW:=7;
   //
   ShellExecute(0, nil, A, nil, nil, SW);
   Invalidate;
   end;
 end;
END;

destructor TStart2w.Destroy;
begin
  Img.Free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Grundic', [TStart2w]);
end;


end.
